unit U_GUI;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.StdCtrls,
  Vcl.Imaging.pngimage;

type
  TFrmGUI = class(TForm)
    BtnLoadWin: TButton;
    BtnOSx: TButton;
    BtnFormIco: TButton;
    BtnSearch_Icon: TButton;
    Image1: TImage;
    TrackBar1: TTrackBar;
    OpenDialog1: TOpenDialog;
    Btn_Hor_Vert: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BtnFormIcoClick(Sender: TObject);
    procedure BtnLoadWinClick(Sender: TObject);
    procedure BtnOSxClick(Sender: TObject);
    procedure BtnSearch_IconClick(Sender: TObject);
    procedure Btn_Hor_VertClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);

  private
    procedure UpdateTrackBar;
  public

  end;

var
  FrmGUI: TFrmGUI;
  S     : String;

implementation

{$R *.dfm}

procedure TFrmGUI.BtnFormIcoClick(Sender: TObject);
begin
  // Add the application icon under Windows
  FrmGUI.Icon.Assign(Image1.Picture.Graphic);
end;

procedure TFrmGUI.FormCreate(Sender: TObject);
begin
  // Fetch the Path where the app is hosted and
  // insert the variable with that for global use
  S:= (ExtractFilePath(Application.ExeName))  ;
end;

procedure TFrmGUI.BtnLoadWinClick(Sender: TObject);
begin
  Image1.Picture.LoadFromFile((S) + 'icons' + PathDelim + 'Delphi.ico');
  // Extracts the path from where the program starts +subdir +file
  Caption := 'Icon found at ' + S + 'icons' + PathDelim + 'Delphi.ico' ;

  UpdateTrackbar;  // See the procedure
end;

procedure TFrmGUI.BtnOSxClick(Sender: TObject);
begin
  ShowMessage('Delphi can not show icons for other OSx')
  // A button taken over from the Lazarus version, where this can be done
end;

procedure TFrmGUI.BtnSearch_IconClick(Sender: TObject);
begin

  try
    If OpenDialog1.Execute
    Then Image1.Picture.LoadFromFile(OpenDialog1.FileName);
    Caption := 'Icon found at Path: ' + OpenDialog1.FileName;
    // Show in the caption area the path
  Except
    MessageDlg('Loading the icon failed', mtError, [mbOK], 0);
  End;

  UpdateTrackbar; // See the procedure
end;

procedure TFrmGUI.Btn_Hor_VertClick(Sender: TObject);
begin
  If Trackbar1.Orientation    = trHorizontal
  then
    begin // Set the orientation of the trackbar
      Trackbar1.Orientation  := trVertical;

      // Change the width of the buttons
      BtnLoadWin.left          :=  + (Trackbar1.Width + 2);
      BtnLoadWin.width         :=    (BtnLoadWin.Width - 25);

      BtnOSx.left              :=  + (Trackbar1.Width + 2);
      BtnOSx.width             :=    (BtnOSx.Width - 25);

      BtnSearch_Icon.left      :=  + (Trackbar1.Width + 2);
      BtnSearch_Icon.width     :=    (BtnSearch_Icon.Width - 25);

      BtnFormIco.left          :=  + (Trackbar1.Width + 2);
      BtnFormIco.width         :=    (BtnFormIco.Width - 25);

      Btn_Hor_Vert.left        :=  + (Trackbar1.Width + 2);
      Btn_Hor_Vert.width       :=    (Btn_Hor_Vert.Width - 25);

    end
  else if Trackbar1.Orientation = trVertical
  then
    begin
    Trackbar1.Orientation      := trVertical;

        BtnLoadWin.left        :=  + 4;
        BtnLoadWin.width       := (BtnLoadWin.Width + 26);

        BtnOSx.left            :=  + 4;
        BtnOSx.width           := (BtnOSx.Width + 26);

        BtnSearch_Icon.left    :=  + 4;
        BtnSearch_Icon.Width   := (BtnSearch_Icon.Width + 26);

        BtnFormIco.left        :=  + 4;
        BtnFormIco.width       :=  (BtnFormIco.width + 26);

        Btn_Hor_Vert.left      :=  + 4;
        Btn_Hor_Vert.width     :=  (Btn_Hor_Vert.Width + 26);

        Trackbar1.Orientation  := trHorizontal  ;
     end;

end;

procedure TFrmGUI.TrackBar1Change(Sender: TObject);
begin
  TrackBar1.Position := ((Image1.Picture.Icon.Width)div 2);
end;

procedure TFrmGUI.UpdateTrackBar;
begin
  if TrackBar1.Enabled then
  begin
    TrackBar1.Min := 0;
    TrackBar1.Max := 160;
    TrackBar1Change(TrackBar1);
  end;
end;

end.
